workflow:
    rules:
        - if: $CI_COMMIT_BRANCH != "master" && $CI_PIPELINE_SOURCE != "merge_request_event"
          when: never
        - when: always

stages:
    - test
    - build 
    - deploy_dev
    - deploy_staging
    - deploy_prod

variables:
    IMAGE_NAME: microservice/shopping-cart
    HOST_USER: linuxadmin

sast:
    stage: test

include:
    - template: Jobs/SAST.gitlab-ci.yml 

run_unit_test:
    stage: test
    tags:
        - local
        - vm 
        - OS-linux
        - docker
        - gitlab-runner-2
    image: node:20 
    before_script:
        - pwd
        - cd app
        - npm install
    script:
        - mkdir d1
        - touch d1/f1
        - echo "Run unit test job" > f1
        - cat f1
    artifacts:
        paths:
            - d1/f1    
    cache:
        key: $CI_COMMIT_REF_NAME
        paths:
            - app/node_modules
        policy: pull-push  

build_image:
    stage: build
    tags: 
        - local
        - vm 
        - OS-linux
        - shell
        - gitlab-runner-1  
    before_script: 
        - export IMAGE_TAG=$(cat app/package.json | jq -r .version).$CI_PIPELINE_IID
        - export IMAGE=$CI_REGISTRY_IMAGE/$IMAGE_NAME:$IMAGE_TAG
        - echo FULL_IMAGE=$IMAGE>build.env
    script: 
        - docker build -t $IMAGE .
    artifacts:
        reports:
            dotenv: build.env

deploy_image:
    stage: build
    needs:
        - build_image  
    dependencies:
        - build_image      
    tags:
        - local
        - vm 
        - OS-linux
        - shell
        - gitlab-runner-1
    before_script:
        - docker login -u $CI_DEPLOY_USER -p $CI_DEPLOY_PASSWORD $CI_REGISTRY
    script:
        - docker push $FULL_IMAGE

.deploy:
    tags:
        - local
        - vm 
        - OS-linux
        - shell
        - gitlab-runner-1
    variables:
            HOST_IP: ""
            APP_PORT: ""
            DEPLOY_ENV: ""
            ENDPOINT: ""
    before_script:
        - pwd
        - ls -l 
        - scp ./compose.yaml $HOST_USER@$HOST_IP:/home/linuxadmin
    script:
        - ssh $HOST_USER@$HOST_IP "docker login -u $CI_DEPLOY_USER -p $CI_DEPLOY_PASSWORD $CI_REGISTRY && 
                                  export IMAGE=$FULL_IMAGE &&
                                  export COMPOSE_PROJECT_NAME=$DEPLOY_ENV &&
                                  export DC_APP_PORT=$APP_PORT &&
                                  docker compose -f compose.yaml down && 
                                  docker compose -f compose.yaml up -d"
    environment:
        name: $DEPLOY_ENV
        url: $ENDPOINT

deploy_to_dev:
    stage: deploy_dev
    extends: .deploy
    variables:
        HOST_IP: 192.168.227.132
        APP_PORT: "3000"
        DEPLOY_ENV: development
        ENDPOINT: http://192.168.227.132:3000 

run_functional_tests:
    stage: deploy_dev
    needs: 
        - deploy_to_dev
    script:
        - echo "testing"            

deploy_to_staging:
    stage: deploy_staging
    extends: .deploy
    variables:
        HOST_IP: 192.168.227.133
        APP_PORT: "4000"
        DEPLOY_ENV: staging
        ENDPOINT: http://192.168.227.133:4000 

run_performance_tests:
    stage: deploy_staging
    needs: 
        - deploy_to_staging
    script:
        - echo "testing"    

deploy_to_prod:
    stage: deploy_prod
    extends: .deploy
    variables:
        HOST_IP: 192.168.227.131
        APP_PORT: "5000"
        DEPLOY_ENV: production
        ENDPOINT: http://192.168.227.131:5000
    when: manual    
